- [HTTP request](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#body.request_body)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#body.response_body)
- [RefundResultNotificationResponse](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResponse)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResponse.SCHEMA_REPRESENTATION)
- [RefundResultNotificationResult](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResult)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResult.SCHEMA_REPRESENTATION)

Notify Google of the result of a refund after a `refund` method call has been made.

Refunds should be handled synchronously during the `refund` method call, but this method provides Google with a fast backup signal in case the synchronous call fails after it has performed the action but before it can return a result. This avoids the delay introduced by Google scheduling a retry for a future time.

The `refundResult` value is idempotent for this `refundRequestId`, so its value can not be changed by a subsequent call to this method.

If the endpoint encounters an error while processing the request, the endpoint will return HTTP 4xx or 5xx and the HTTP body will either be of type [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse) or contain a generic error (e.g. a message similar to "There was an error. Please try again later.").

The generic error is used in situations where an [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse) with a clear description could be used to help an attacker understand the payment integrator account identifier of other integrators. In these situations, where either the signing key doesn't match, the payment integrator identifier was not found, or the encryption key was unknown, this method will return a generic error. If the request signature could be verified, additional information regarding the error will be returned in an [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse).

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1,
          "minor": 1,
          "revision": 0
        },
        "requestId": "HsKv5pvtQKTtz7rdcw1YqE",
        "requestTimestamp": "1481855928301"
      },
      "paymentIntegratorAccountId": "InvisiCashUSA_USD",
      "refundRequestId": "hH1T32PI86CpKwjuf6oD2r",
      "refundResult": "SUCCESS"
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": "1481855928376"
      },
      "result": {
        "accepted": {}
      }
    }

### HTTP request

`POST https://vgw.googleapis.com/gsp/refundable-one-time-payment-code-v1/refundResultNotification/https://developers.google.com/pay/refundable-one-time-payment-code-v1/reference/glossary#payment_integrator_account_id`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/RequestHeader) }, "paymentIntegratorAccountId": string, "refundRequestId": string, "refundResult": enum (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/refund#RefundResultCode), "paymentIntegratorRefundId": string } ``` |

| Fields ||
|---|---|
| `requestHeader` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/RequestHeader)` **REQUIRED**: Common header for all requests. |
| `paymentIntegratorAccountId` | `string` **REQUIRED**: Payment integrator account identifier on which the refund occurred. |
| `refundRequestId` | `string` **REQUIRED** : Unique identifier for this refund, established by the `requestId` field when the `refund` method was called. |
| `refundResult` | `enum (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/refund#RefundResultCode)` **REQUIRED**: Result of this refund. |
| `paymentIntegratorRefundId` | `string` **REQUIRED**: This identifier is specific to the integrator and is generated by the integrator. This is the identifier that the integrator knows this refund by. For convenience, this identifier is included with in the remittance details |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/refundable-one-time-payment-code-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResponse`)`` |
| HTTP 4XX / 5XX Status | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse)` |
| End of mutually exclusive fields. ||

## RefundResultNotificationResponse

Response object for the `refundResultNotification` method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ResponseHeader) }, "result": { object (`https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResult`) } } ``` |

| Fields ||
|---|---|
| `responseHeader` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/ResponseHeader)` **REQUIRED**: Common header for all responses. |
| `result` | ``object (`https://developers.google.com/pay/refundable-one-time-payment-code-v1/google-refundable-one-time-payment-code-api/refundResultNotification#RefundResultNotificationResult`)`` **REQUIRED**: Result of this call. |

## RefundResultNotificationResult

Result messages for the `refundResultNotification` method.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "accepted": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/Empty) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED** : The result of this `refundResultNotification` call. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `accepted` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v1/payment-integrator-refundable-one-time-payment-code-api/Empty)` Refund result notification was accepted |
| End of mutually exclusive fields. ||